- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ codimd_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ codimd_name }}-to-{{ ldap_name | default('ldap') }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_ldap
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ ldap_name | default('ldap') }}"
    to:
    - number: "1389"
    - number: "1636"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ codimd_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ codimd_name }}-to-{{ lemon_name | default('lemon') }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_lemon
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ lemon_name | default('lemon') }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ codimd_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ codimd_name }}-to-s3"
    policy_namespace: "{{ (minio_namespace | default('minio'))
                            if (minio_api_address | default(False))
                            else ((rgw_namespace | default('radosgw'))
                                  if (radosgw_api_address | default(False))
                                  else namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and (minio_api_address | default(False)
                                         or radosgw_api_address | default(False))
                                    and do_s3)
                                else 'absent' }}"
    subject: "{{ (minio_name | default('s3')) if (minio_api_address | default(False))
                                              else (rgw_name | default('s3')) }}"
    to:
    - number: "{{ 9000 if (minio_api_address | default(False))
                       else 8080 }}"
- include_role:
    name: commons
    tasks_from: helpers/volume.yaml
  vars:
    vol_access_mode: "{{ 'ReadWriteOnce' if (rwx_storage is not defined)
                                         else 'ReadWriteMany' }}"
    vol_name: "{{ codimd_name }}"
    vol_size: "{{ codimd_data_capacity }}"
  when:
  - not do_s3
  - not codimd_imgur_client_id
- include_role:
    name: commons
    tasks_from: helpers/deployment.yaml
  vars:
    cone_cpu_limit: "{{ sshd_cpu_limit }}"
    cone_cpu_request: "{{ sshd_cpu_request }}"
    cone_idx: "{{ 1 if (do_backups
                        and not codimd_imgur_client_id
                        and not do_s3)
                    else 0 }}"
    cone_memory_limit: "{{ sshd_memory_limit }}"
    cone_memory_request: "{{ sshd_memory_request }}"
    cone_tag: "{{ sshd_tag }}"
    cpu_limit: "{{ codimd_cpu_limit }}"
    cpu_request: "{{ codimd_cpu_request }}"
    dc_data: "{{ lookup('template', 'codimd.j2') }}"
    dc_name: "{{ codimd_name }}"
    dc_replicas: "{{ 1 if (((cd_dc.resources | default([])) | length == 0)
                           or ((has_pvc.resources | default([])) | length > 0
                               and has_pvc.resources[0].spec.accessModes[0] == 'ReadWriteMany'))
                       else codimd_replicas }}"
    dc_tag: "{{ codimd_tag }}"
    memory_limit: "{{ codimd_memory_limit }}"
    memory_request: "{{ codimd_memory_request }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 3000
    svc_name: "{{ codimd_name }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 2222
    svc_name: "backups-{{ codimd_name }}"
    svc_selector: "{{ codimd_name }}"
    svc_state: "{{ 'present' if (do_backups
                                 and not codimd_imgur_client_id
                                 and not do_s3)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: k8s-backups
    policy_matchkey: backups-opsperator
    policy_name: "backups-to-{{ codimd_name }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and not codimd_imgur_client_id
                                    and not do_s3
                                    and do_backups)
                                else 'absent' }}"
    subject: "{{ codimd_name }}"
    to:
    - number: "2222"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    deny_paths:
    - /metrics/router
    route_host: "{{ codimd_fqdn }}"
    route_name: "{{ codimd_name }}"
    svc_name: "{{ codimd_name }}"
#FIXME: deny_paths not implemented with OKD!
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ codimd_name }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ codimd_name }}"
    to:
    - number: "3000"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 3000
    svc_metrics_path: /metrics/router
    svc_name: "{{ codimd_name }}"
    svc_state: "{{ 'present' if (do_exporters)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match }}"
    policy_name: "prometheus-to-{{ codimd_name }}"
    policy_state: "{{ 'present' if (do_exporters
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ codimd_name }}"
    to:
    - number: "3000"
- include_role:
    name: commons
    tasks_from: helpers/wait-for.yaml
  vars:
    check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                           kind=deployment_kind, namespace=namespace,
                           resource_name=codimd_name) | default('') }}"
    obj_name: "{{ codimd_name }}"
    retries_for: 30
    wait_for: 10
  when:
  - dc_started is defined
  - dc_started is changed
- include_role:
    name: commons
    tasks_from: helpers/autoscale.yaml
  vars:
    autoscale_cpu_target: "{{ codimd_hpa_cpu_target | default(hpa_cpu_target | default(75)) }}"
    autoscale_name: "{{ codimd_name }}"
    autoscale_state: "{{ 'present' if (codimd_replicas not in [ 0, '0' ]
                                       and (rwx_storage is defined
                                            or do_s3
                                            or codimd_imgur_client_id)
                                       and ((has_pvc.resources | default([])) | length == 0
                                            or ((has_pvc.resources | default([])) | length > 0
                                                and has_pvc.resources[0].spec.accessModes[0] == 'ReadWriteMany')))
                                   else 'absent' }}"
    max_replicas: "{{ codimd_max_replicas | default(hpa_max_replicas | default(4)) }}"
    min_replicas: "{{ codimd_min_replicas | default(codimd_replicas) }}"
- include_role:
    name: commons
    tasks_from: helpers/poddisruptionbudget.yaml
  vars:
    pdb_name: "{{ codimd_name }}"
    pdb_min_available: 1
    pdb_state: "{{ 'present' if ((codimd_replicas | int) > 1
                                 and do_pdb)
                             else 'absent' }}"
